--------------------------------------------------------------------------------
--
-- Title       : Scanner FPGA
-- Design      : Decoder_InxOut Test
-- Author      : Alex Shtengel
-- Company     : Home
--------------------------------------------------------------------------------
-- File        : Decoder_InxOut_Tb.vhd
-- Generated   : May 21  2020
--------------------------------------------------------------------------------
-- Description : Decoder
--------------------------------------------------------------------------------
-- Revision History :
-- -----------------------------------------------------------------------------
--   Ver  :| Author            :| Mod. Date :|    Changes Made:
--   v1.0  | Alex Shtengel	   :| 21/05/20	:| Automatically Generated
-- -----------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


entity Decoder_InxOut_Tb is
end Decoder_InxOut_Tb;

architecture ArchDecoder_InxOut_Tb of Decoder_InxOut_Tb is
signal Clock       																 		 		 		 		 		 					-- Clock 30.000 MHz
										: std_logic := '0';
signal nReset          																													-- General Reset active Low
										: std_logic := '1';
signal Input
 										: std_logic_vector(3 downto 0):= (others => '0');						-- Input number for decoding
signal OutputSel
										: std_logic_vector(15 downto 0):= (others => '0');


begin
Clock 		<= not Clock after 10 nS;     																				-- Clock 50.000 MHz
nReset		<= '1','0' after 30 nS,'1' after 100 nS;         											-- General Reset active Low

Decoder_InxOut_UUT : entity work.Decoder_InxOut
GENERIC MAP(3,15)
port map
(
 ClockIn 			=> Clock,      																										-- General Clock
 nResetIn			=> nReset,																												-- General Reset active low
 Input 				=> Input,																													-- Input number for decoding
 OutputSel		=> OutputSel    																									-- Outputs
);

 Test_Process:
PROCESS
variable i : integer range 0 to 17 := 0;
begin
 if(i = 0) then
  wait until nReset'event and nReset = '0';
  wait until nReset'event and nReset = '1';
 end if;
	DecLoop:
			Input <= conv_std_logic_vector(i,4);
 		  wait until Clock'event and Clock = '1';
			 i:=i+1;
			if(i = 17) then
			 Input <= (others => '0');
			 wait;
		 	end if;
end process  Test_Process;

end ArchDecoder_InxOut_Tb;
